#include <jni.h>
#include <stdio.h>
#include "speex/speex.h"

 #define FRAME_SIZE 320


void Java_com_m2_iSmartDm_ISmartDMActivity_spxEnc(JNIEnv * env, jobject jobj,jstring dir1,jstring dir2)
{
	const char *inFile= (*env)->GetStringUTFChars(env,dir1,0);
	const char *outFile= (*env)->GetStringUTFChars(env,dir2,0);

	
	 FILE *fin;
	 FILE *fout;
	 short in[FRAME_SIZE];
	 float input[FRAME_SIZE];
	 char cbits[360];
	 int nbBytes;

	 
	 void *state;

	 SpeexBits bits;
	 int i, tmp;

	 
	 state = speex_encoder_init(&speex_wb_mode);

	 
	 tmp=8;
	 speex_encoder_ctl(state, SPEEX_SET_QUALITY, &tmp);

	  fin = fopen(inFile, "r");
	  fout=fopen(outFile,"w");
	  speex_bits_init(&bits);

	  int bool=1;
	  

	  while (!feof(fin))
	  {
		  if(bool==1)
		  {
		    /*  skip wav header */
		    fseek ( fin , 44 , SEEK_SET );  
		    bool=0;
		  }

	  	/*Read a 16 bits/sample audio frame*/
	  	 fread(in, sizeof(short), FRAME_SIZE, fin);
	 	 if (feof(fin))
	 		 break;

	 
	 	 speex_bits_reset(&bits);

	 
	 	 speex_encode_int(state, in, &bits);
	  
		  nbBytes = speex_bits_write(&bits, cbits, 360);

	 
	 	 fwrite(&nbBytes, sizeof(int), 1, fout);

	 	 /*Write the compressed data*/
	 	 fwrite(cbits, 1, nbBytes, fout);

	  }

	  speex_encoder_destroy(state);
	  speex_bits_destroy(&bits);
	  fclose(fin);
	  fclose(fout);

}
